/*

Mike DeFehr Sept 2009
mike@defehr.com
http://mikedefehr.com
http://winnipeg.sqlpass.org/

*/

USE tempdb
IF OBJECT_ID('OrderDetails') IS NOT NULL DROP TABLE OrderDetails
IF OBJECT_ID('Orders') IS NOT NULL DROP TABLE Orders
CREATE TABLE Orders
(	OrderID			int PRIMARY KEY,
	OrderDate		date,
	CustomerName	varchar(255)
)
CREATE TABLE OrderDetails
(	OrderDetailID	int PRIMARY KEY,
	OrderID			int
		CONSTRAINT FK_OrderDetails_Orders
		FOREIGN KEY REFERENCES Orders(OrderID),
	ItemName		varchar(255),
	OrderQty		decimal(19,4),
	ItemPrice		money
)
GO

INSERT Orders (OrderID, OrderDate, CustomerName) VALUES
(1,'2009-09-01','Kern-Hill Furniture'),
(2,'2009-09-01','Leons'),
(3,'2009-09-01','The Brick'),
(4,'2009-09-01','Dufresne')

INSERT OrderDetails (OrderDetailID, OrderID,ItemName,OrderQty,ItemPrice) VALUES
(1, 1,'Dresser',5,500),
(2, 1,'Nightstand',10,150),
(3, 1,'Headboard',5,200),
(4, 2,'Dresser',25,500),
(5, 2,'Nightstand',50,150),
(6, 2,'Headboard',25,200),
(7, 3,'Dresser',25,500),
(8, 3,'Nightstand',45,150),
(9, 3,'Headboard',25,200),
(10,4,'Dresser',10,500),
(11,4,'Nightstand',20,150),
(12,4,'Headboard',10,200)


SELECT	o.CustomerName, o.OrderDate, od.ItemName, od.OrderQty, od.ItemPrice
FROM Orders o
	JOIN OrderDetails od ON o.OrderID = od.OrderID
ORDER BY o.CustomerName, od.ItemName



--application code
DECLARE @OD TABLE 
(	OrderDetailID	int PRIMARY KEY,
	OrderID			int,
	ItemName		varchar(255),
	OrderQty		decimal(19,4),
	ItemPrice		money
)

INSERT @OD
SELECT * FROM OrderDetails
WHERE OrderID = 3

SELECT * FROM @OD

UPDATE @OD SET OrderQty = 50 WHERE OrderDetailID = 8
INSERT @OD (OrderDetailID, OrderID,ItemName,OrderQty,ItemPrice) VALUES
(13, 3,'Armoire',25,500)
DELETE FROM @OD WHERE OrderDetailID = 7

SELECT * FROM @OD

MERGE INTO OrderDetails tgt
USING @OD src
ON tgt.OrderDetailID = src.OrderDetailID
WHEN MATCHED AND (	tgt.ItemName <> src.ItemName
				OR	tgt.OrderQty <> src.OrderQty
				OR	tgt.ItemPrice <> src.ItemPrice	) THEN 
UPDATE
SET	ItemName = src.ItemName,
	OrderQty = src.OrderQty,
	ItemPrice = src.ItemPrice
WHEN NOT MATCHED BY TARGET THEN
INSERT	(	OrderDetailID,
			OrderID,
			ItemName,
			OrderQty,
			ItemPrice
		)
VALUES	(	src.OrderDetailID,
			src.OrderID,
			src.ItemName,
			src.OrderQty,
			src.ItemPrice
		)
WHEN NOT MATCHED BY SOURCE and tgt.OrderID = 3 THEN
	DELETE
OUTPUT	$Action AS ChangeType,
		COALESCE(src.OrderDetailID,deleted.OrderDetailID) AS OrderDetailID,
		COALESCE(src.OrderID,deleted.OrderID) AS OrderID,
		COALESCE(src.ItemName,deleted.ItemName) AS ItemName,
		COALESCE(src.OrderQty,deleted.OrderQty) AS OrderQty,
		COALESCE(src.ItemPrice,deleted.ItemPrice) AS ItemPrice;


SELECT o.OrderID, o.CustomerName, o.OrderDate, od.ItemName, od.OrderDetailID, od.OrderQty, od.ItemPrice
FROM Orders o
	JOIN OrderDetails od ON o.OrderID = od.OrderID
ORDER BY o.CustomerName, od.ItemName

